# TorchCraftAI

TorchCraftAI is a platform that lets you build agents to play (and learn to play) *StarCraft®: Brood War®*†. TorchCraftAI includes:
- A modular framework for building StarCraft agents
- CherryPi, a bot which plays complete games of StarCraft (1st place SSCAIT 2017-18)
- A reinforcement learning environment with minigames, models, and training loops
- TorchCraft support for TCP communication with StarCraft and BWAPI
- Support for Linux, Windows, and OSX

## Get started

See guides for:

- [Linux](https://torchcraft.github.io/TorchCraftAI/docs/install-linux.html)
- [Windows](https://torchcraft.github.io/TorchCraftAI/docs/install-windows.html)
- [OSX](https://torchcraft.github.io/TorchCraftAI/docs/install-macos.html)

## Documentation

* [Home](https://torchcraft.github.io/TorchCraftAI)
* [Architecture overview](https://torchcraft.github.io/TorchCraftAI/docs/architecture.html)
* [Code reference](https://torchcraft.github.io/TorchCraftAI/reference/)

### Tutorials

* [Train a model to place buildings](https://torchcraft.github.io/TorchCraftAI/docs/bptut-intro.html)
* [Train a model to fight](https://torchcraft.github.io/TorchCraftAI/docs/microtut-intro.html)

## Licensing

We encourage you to experiment with TorchCraftAI! See [LICENSE](https://github.com/TorchCraft/TorchCraftAI/blob/master/LICENSE), plus more on [contributing](https://github.com/TorchCraft/TorchCraftAI/blob/master/CONTRIBUTING.md) and our [code of conduct](https://github.com/TorchCraft/TorchCraftAI/blob/master/CODE_OF_CONDUCT.md).

†: StarCraft is a trademark or registered trademark of Blizzard Entertainment, Inc., in the U.S. and/or other countries.  Nothing in this repository should be construed as approval, endorsement, or sponsorship by Blizzard Entertainment, Inc.
